# ultimate_buyscript.py by [#OMEGA] - K2 (V 3.00)
# Do not modify or use in your script without my permission (unless you don't make it public)
# Feel free to share

# TODO:
# DONE weapon restriction
# DONE -> Simple Pickup Check
# -> Advanced Pickup Checks (allows pickup if the weapon is enabled in ubuy)
# -> Regular buy restriction
# DONE - stripping player weapons (purchase)
# DONE - weapon flags
# DONE - allowing ppl to change the buy command
# allowing ppl to add custom items to buymenu
# code cleanup
# Redo popups
# Cut down imports
# DONE - Verify duplciate Check
# Add new stuff to the popups

import es
import gamethread
import playerlib
import popuplib

from os.path import exists
from langlib import Strings
from time import time
from ConfigParser import SafeConfigParser

items = {'glock': 2, 'usp': 2, 'p228': 2, 'deagle': 2, 'fiveseven': 2, 'elite': 2, 'm3': 1, 'xm1014': 1, 'mac10': 1, 'tmp': 1, 'mp5navy': 1, 'ump45': 1, 'p90': 1, 'galil': 1, 'ak47': 1, 'sg552': 1, 'famas': 1, 'm4a1': 1, 'aug': 1, 'scout': 1, 'g3sg1': 1, 'sg550': 1, 'awp': 1, 'm249': 1, 'hegrenade': 0, 'flashbang': 0, 'smokegrenade': 0, 'vest': -1, 'vesthelm': -1, 'nvgs': 0, 'defuser': 0}

info = es.AddonInfo()
info.name        = "Ultimate Buyscript"
info.version     = "3.00"
info.author      = "[#OMEGA] - K2"
info.url         = "http://forums.mattie.info/cs/forums/viewtopic.php?t=18741"
info.description = "Allows you to purchase weapons per popup or command. Highly customable: restict single items per team, change cost, etc. It is also possible to enable & disable the checking for buyzone, price, team and buytime."
info.tags 		 = "ultimate buyscript buy weapons purchase langlib playerlib popuplib" 

lang = Strings(es.getAddonPath("ultimate_buyscript") + "/strings.ini")

cfg = SafeConfigParser()
cfg.read(es.getAddonPath("ultimate_buyscript") + "/config.ini")

version = "%s V %s" % (info.name,info.version)
languages = ['en','de']

# Error Classes..

class ConfigError(Exception):
	'''
	Just for rasing errors :D
	'''
	pass
	
# Load & unload functions...

def load():
	# Register Vars
	es.set('ubuy_alive_check',1,"Enables or disables alive check.")	
	es.set('ubuy_buyzone_check',1,"Enables or disables buyzone check.")
	es.set('ubuy_enabled_check',1,"Enables or disables enabled check.")
	es.set('ubuy_price_check',1,"Enables or disables the price check.")
	es.set('ubuy_buytime_check',1,"Enables or disables the buytime check.")
	es.set('ubuy_duplicate_check',1,"Enables or disables the duplicate check.")
	es.set('ubuy_adverts',1,"Enables or disables the connect adverts.")
	es.set('ubuy_drop_weapons',1,"""Setting this to 0will try to strip the player's weapons before giving the weapon.\n
	setting this to 1 will try to drop the player's weapon instead.""")
	es.set('ubuy_restrictions',"","""Sets weapon restriction for every particular weapon.\n
	Weapons have to be seperated by a comma (,).""")
	es.set('ubuy_restriction_sound',"buttons/weapon_cant_buy.wav","""Sets the path to the sound to play when someone tries to purchase a restricted weapon.\n
	Leave empty to disable\n
	Note: The path is realtive to cstrike/sound/""")
	es.set('ubuy_restriction_sound_downloadable',0,"Enables or disables downloading the soundfile")
	es.set('ubuy_simple_team_check',1,"Enables or disables the simple team check mode.")
	es.set('ubuy_advanced_team_check',0,"Enables or disables the advanced team check mode.")
	es.set('ubuy_team_type',2,"""Sets the team which is allowed to buy weapons.\n
	0 = Any Team\n
	2 = Terrorists\n
	3 = Counter-Terrorists""")
	for weapon in items:
		es.set('ubuy_%s_enabled' % weapon,0,"Enables or disables purchasing.")
		es.set('ubuy_%s_cost' % weapon,0,"Sets the weapon price.")
		es.set('ubuy_%s_team' % weapon,0,"""Sets the team which is allowed to buy this weapon.\n
		0 = Any Team\n
		2 = Terrorists\n
		3 = Counter-Terrorists""")
		es.set('ubuy_%s_flags' % weapon,0,"""Check Flags. Add up the numbers for the checks you would like to enable.\n
		-1 = Disabled\n
		0 = No Checks\n
		1 = Enabled Check\n
		2 = Alive Check\n
		4 = Simple Team Check\n
		8 = Advanced Team Check\n
		16 = Buytime Check\n
		32 = Buyzone Check\n
		64 = Duplicate Check\n
		128 = Money Check""")
	es.set('ultimate_buyscript_version',version,"Script Version")
	es.makepublic('ultimate_buyscript_version')
	es.mexec('../addons/eventscripts/ultimate_buyscript/ultimate_buyscript.cfg')
	gamethread.delayed(0.1,load_delayed)
	global round_time
	round_time = int(time())
	
def load_delayed():
	# Parse the commands
	global commands
	commands = {'say': {'P': [],'S':[]},
	'popup': {'P': [],'S':[]},
	'helpmenu': {'P': [],'S':[]}}
	for cmdtype in commands:
		commandlist = cfg.get('main settings','%s_command_list' % cmdtype)
		if len(commandlist) == 0:
			commands[cmdtype] = None
		else:
			for item in commandlist.split(','):
				temp = item.split(':')
				if temp[0] in ['P','S']:
					commands[cmdtype][temp[0]].append(temp[1])
				else:
					raise ConfigError,'Error parsing config.ini, expected P or S flag but got: %s' % temp[0]
	# Register console commands incase this is enabled
	concmds = cfg.getboolean('main settings','register_console_commands')
	if concmds:
		for cmdtype in commands:
			for flag in commands[cmdtype]:
				for command in commands[cmdtype][flag]:
					es.regclientcmd(command.strip('!@/'),'ultimate_buyscript/%s' % cmdtype.replace('say','buy'),"Purchases the specified weapon.")
	# Register any silent SAY comand now
	for command in commands['say']['S']:
		es.regsaycmd(command,'ultimate_buyscript/buy',"Purchases the specified weapon.")
	# Only create the popups if there are any popup commands
	if commands['popup'] != None:
		for command in commands['popup']['S']:
			es.regsaycmd(command,'ultimate_buyscript/popup',"Shows the popupmenu.")
		weaponmenu = popuplib.create('weaponmenu')
		pistols = popuplib.create('pistols')
		shotguns = popuplib.create('shotguns')
		smgs = popuplib.create('smgs')
		rifles = popuplib.create('rifles')
		sniper = popuplib.create('sniper')
		machineguns = popuplib.create('machineguns')
		equipment = popuplib.create('equipment')
		popups = {weaponmenu: ['wcategory',' ','pistols','shotguns','smgs','rifles','sniper','mg','equipment',' ','close'],pistols: ['pistols',' ','glock','usp','p228','deagle','fiveseven','elite',' ','mainmenu','close'],shotguns: ['shotguns',' ','m3','xm1014',' ','mainmenu','close'],smgs: ['smgs',' ','tmp','mac10','mp5navy','ump45','p90',' ','mainmenu','close'],rifles: ['rifles',' ','galil','famas','ak47','m4a1','sg552','aug',' ','mainmenu','close'],sniper: ['sniper',' ','scout','g3sg1','sg550','awp',' ','mainmenu','close'],machineguns: ['mg',' ','m249',' ','mainmenu','close'],equipment: ['equipment',' ','vest','vesthelm','flashbang','hegrenade','smokegrenade','nvgs','defuser',' ','mainmenu','close']}
		for popup in popups:
			popup_construct(popup,popups[popup])
		i = 0
		for callback in [pistols,shotguns,smgs,rifles,sniper,machineguns,equipment]:
			callback.submenu(9,weaponmenu)
			i += 1
			weaponmenu.submenu(i,callback)
			callback.menuselect = chosen
	if commands['helpmenu'] != None:
		for command in commands['helpmenu']['S']:
			es.regsaycmd(command,'ultimate_buyscript/helpmenu',"Shows the Helpmenu.")
		helpmenu = popuplib.create('helpmenu')
		commandsmenu = popuplib.create('commands')
		settings = popuplib.create('settings')
		plugininfo = popuplib.create('plugininfo')
		weaponsettings = popuplib.create('weaponsettings')
		pistols_i = popuplib.create('pistols_i')
		shotguns_i = popuplib.create('shotguns_i')
		smgs_i = popuplib.create('smgs_i')
		rifles_i = popuplib.create('rifles_i')
		sniper_i = popuplib.create('sniper_i')
		machineguns_i = popuplib.create('machineguns_i')
		equipment_i = popuplib.create('equipment_i')
		# Mainmenu
		helpmenu.addlineAll(version)
		helpmenu.addlineAll('---------------------------')
		popup_construct(helpmenu,['category',' ','pinfo','pcommands','psettings','wsettings',' ','close'])
		# Pinfo
		popup_construct(plugininfo,['pinfo',' '])
		for lng in languages:
			plugininfo.addline(lang('pinfo_p1',{'ubuy': "[#OMEGA] - K2's Ultimate Buyscript"},lng),lng)
		popup_construct(plugininfo,['pinfo_p2','pinfo_p3',' '])
		for lng in languages:
			plugininfo.addline(lang('pinfo_p4',{'email': 'omegak2@gmx.de'},lng),lng)
		popup_construct(plugininfo,['pinfo_p5'])
		plugininfo.addlineAll('IP: 81.19.209.199:27200')
		popup_construct(plugininfo,[' ','mainmenu','close'])
		# Cmds
		popup_construct(commandsmenu,['pcommands',' ','saycmds'])
		for lng in languages:
			for string in ['ubuy','umenu','uhelp']:
				commandsmenu.addline('!%s' % lang(string,lang=lng),lng)
		popup_construct(commandsmenu,[' ','consolecmds','ubuy','umenu','uhelp',' ','mainmenu','close'])
		# Settings
		popup_construct(settings,['psettings',' ','psettings_info',' '])
		popup_construct(settings,{'psettings_console': {'var': cfg.getboolean('main settings','register_console_commands')},'psettings_say': {'var': bool(cfg.get('main settings','say_command_list'))},'psettings_popup': {'var': bool(cfg.get('main settings','popup_command_list'))},'psettings_buyzone': {'var': es.getString('ubuy_buyzone_check')},'psettings_price': {'var': es.getString('ubuy_price_check')},'psettings_enabled': {'var': es.getString('ubuy_enabled_check')},'psettings_buytime': {'var': es.getString('ubuy_buytime_check')}},1)
		popup_construct(settings,[' ','mainmenu','close'])
		# Wsettings
		popup_construct(weaponsettings,['wsettings',' ','format_t','format',' ','pistols','shotguns','smgs','rifles','sniper','mg','equipment',' ','mainmenu','close'])
		popups = {pistols_i: ['pistols',' ','glock','usp','p228','deagle','fiveseven','elite',' ','weaponmenu','mainmenu','close'],shotguns_i: ['shotguns',' ','m3','xm1014',' ','weaponmenu','mainmenu','close'],smgs_i: ['smgs',' ','mac10','tmp','mp5navy','ump45','p90',' ','weaponmenu','mainmenu','close'],rifles_i: ['rifles',' ','galil','famas','ak47','m4a1','sg552','aug',' ','weaponmenu','mainmenu','close'],sniper_i: ['sniper',' ','scout','g3sg1','sg550','awp',' ','weaponmenu','mainmenu','close'],machineguns_i: ['mg',' ','m249',' ','weaponmenu','mainmenu','close'],equipment_i: ['equipment',' ','vest','vesthelm','flashbang','hegrenade','smokegrenade','nvgs','defuser',' ','weaponmenu','mainmenu','close']}
		for popup in popups:
			popup_construct(popup,popups[popup],help=1)
		helpmenu.submenu(1,plugininfo)
		helpmenu.submenu(2,commands)
		helpmenu.submenu(3,settings)
		helpmenu.submenu(4,weaponsettings)
		weaponsettings.submenu(9,helpmenu)
		plugininfo.submenu(9,helpmenu)
		commandsmenu.submenu(9,helpmenu)
		settings.submenu(9,helpmenu)
		weaponsettings.submenu(9,helpmenu)
		i = 0
		for callback in [pistols_i,shotguns_i,smgs_i,rifles_i,sniper_i,machineguns_i,equipment_i]:
			callback.submenu(9,helpmenu)
			callback.submenu(8,weaponsettings)
			i += 1
			weaponsettings.submenu(i,callback)
	AddDownloads()
		
def popup_construct(callback,strings,tokens=0,help=0):
	for lng in languages:
		i = 0
		if not tokens:
			for string in strings:
				if string == ' ':
					callback.addline(' ',lng)
				elif help == 0 and string in items:
					i += 1
					callback.addline('->%i. %s' % (i,lang(string,lang=lng).split(' [')[0]),lng)
				elif (strings[0] in ['wsettings','wcategory'] and string in ['pistols','shotguns','smgs','rifles','sniper','mg','equipment']) or (strings[0] == 'category' and string in ['pinfo','pcommands','psettings','wsettings']):
					i += 1
					callback.addline('->%i. %s' % (i,lang(string,lang=lng)),lng)
				elif help == 1 and string in items:
					i += 1
					callback.addline('->%i. %s %s %s %s$' % (i,lang(string,lang=lng).split(' [')[0],es.getString('ubuy_%s_enabled' % string),es.getString('ubuy_%s_team' % string),es.getString('ubuy_%s_cost' % string)),lng)
				else:
					callback.addline(lang(string,lang=lng),lng)
		else:
			for string in strings:
				callback.addline(lang(string,strings[string],lng),lng)
def unload():
	es.set('ultimate_buyscript_version','Unloaded')
	global commands
	for cmdtype in commands:
		if cfg.getboolean('main settings','register_console_commands'):
			for flag in commands[cmdtype]:
				for command in commands[cmdtype][flag]:
					es.unregclientcmd(command.strip('!@/'))
		for command in commands[cmdtype]['S']:
			es.unregsaycmd(command)
	for userid in es.getUseridList():
		unsend_popups(userid)
	if commands['popup'] != None:
		for popup in ['weaponmenu','pistols','shotguns','smgs','rifles','sniper','machineguns','equipment']:
			popuplib.delete(popup)
	if commands['helpmenu'] != None:
		for popup in ['helpmenu','commands','settings','plugininfo','weaponsettings','pistols_i','shotguns_i','smgs_i','rifles_i','sniper_i','machineguns_i','equipment_i']:
			popuplib.delete(popup)

#	
# Events
#
def es_map_start(ev):
	AddDownloads()

def item_pickup(ev):
	item = ev['item']
	if item in es.getString('ubuy_restrictions').split(','):
		userid = ev['userid']
		# Drop it
		drop(userid,'weapon_' + item)
		# Play the Restriction sound
		sound = es.getString('ubuy_restriction_sound')
		if sound != "":
			es.playsound(userid,sound, 1.0)
		# Send them a message
		msg(userid,'restricted',{'weapon': lang(item,lang=playerlib.getPlayer(userid).get('lang'))})
	
def round_start(ev):
	global round_time
	round_time = int(time())
	
def player_activate(ev):
	chk = es.getInt('ubuy_adverts')
	if chk == 1:
		userid = ev['userid']
		msg(userid,'info',{'version': "[#OMEGA] - K2's %s" % version})
		for item in ['register_console_commands','say_command_list','popup_command_list','helpmenu_command_list']:
			chk = int(bool(cfg.get('main settings',item)))
			if not (item == 'helpmenu_command_list' and chk == 0):
				msg(userid,'%s_%s' % (item,chk))
	elif chk != 0:
		msg(userid,'variable error',{'var': 'ubuy_adverts'})
	
	
#
# Popups
#	
def unsend_popups(userid):
	if bool(cfg.get('main settings','popup_command_list')):
		for popup in ['weaponmenu','pistols','shotguns','smgs','rifles','sniper','machineguns','equipment']:
			popuplib.unsendname(popup,userid)
	if bool(cfg.get('main settings','helpmenu_command_list')):
		for popup in ['helpmenu','commands','settings','plugininfo','weaponsettings','pistols_i','shotguns_i','smgs_i','rifles_i','sniper_i','machineguns_i','equipment_i']:
			popuplib.unsendname(popup,userid)

def popup():
	SendPopup('weaponmenu',es.getcmduserid())
	
def helpmenu():
	SendPopup('helpmenu',es.getcmduserid())	

def SendPopup(popup,userid):
	unsend_popups(userid)
	popuplib.send(popup,userid)
	
def chosen(userid,choice,popup):
	if popup == 'pistols' and choice <= 6:
		args = ['glock','usp','p228','deagle','fiveseven','elite']
		chosen2(userid,args[choice - 1])
	elif popup == 'shotguns' and choice <= 2:
		args = ['m3','xm1014']
		chosen2(userid,args[choice - 1])
	elif popup == 'smgs' and choice <= 5:
		args = ['tmp','mac10','mp5navy','ump45','p90']
		chosen2(userid,args[choice - 1])
	elif popup == 'rifles' and choice <= 6:
		args = ['galil','famas','ak47','m4a1','sg552','aug']
		chosen2(userid,args[choice - 1])
	elif popup == 'sniper' and choice <= 4:
		args = ['scout','g3sg1','sg550','awp']
		chosen2(userid,args[choice - 1])
	elif popup == 'machineguns' and choice == 1:
		chosen2(userid,'m249')
	elif popup == 'equipment' and choice <= 7:
		args = ['vest','vesthelm','flashbang','hegrenade','smokegrenade','nvgs','defuser']
		chosen2(userid,args[choice - 1])
	
def chosen2(userid,arg):
	unsend_popups(userid)
	check(userid,arg)

#
# Main Script
#
def player_say(ev):
	global commands
	text = ev['text']
	for command in commands['say']['P']:
		if text.startswith(command):
			check(ev['userid'],text.replace(command + ' ',''),True)
	for command in commands['popup']['P']:
		if text == command:
			SendPopup('weaponmenu',ev['userid'])
	for command in commands['helpmenu']['P']:
		if text == command:
			SendPopup('helpmenu',ev['userid'])

def buy():
	check(es.getcmduserid(),es.getargv(1),True)

class check(object):
	userid = None
	item = None
	flags = None
	error = False
	data = None
	def __init__(self,userid,item,ic=False):
		self.item = item
		# Is the specified item valid?
		if ic:
			if self.item != None:
				if self.item not in items:
					self.error = True
					msg(userid,'invalid_weaponname')
			else:
				self.error = True
				msg(userid,'no_weaponname')
		if not self.error:
			# Create the remaining data
			self.data = {1: [self.check,self.enabled,'enabled'],
			2: [self.check,self.alive,'alive'],
			3: [self.check,self.team_simple,'simple_team'],
			4: [self.check,self.team_advanced,'advanced_team'],
			5: [self.check,self.buytime,'buytime'],
			6: [self.check,self.buyzone,'buyzone'],
			7: [self.check,self.duplicate,'duplicate'],
			8: [self.money_check,self.money,'price']}
			self.userid = userid
			# Is the item using flags?
			self.flags = es.getInt('ubuy_%s_flags' % self.item)
			if self.flags == -1:
				self.flags = None
			elif 0 <= self.flags <= (2 ** len(self.data) - 1):
				self.flags = self.bin(self.flags,len(self.data))
			else:
				self.errormsg('ubuy_%s_flags' % self.item)
			# Start our loop checking the items.
			id = 1
			while self.error == False:
				if not self.flags:
					if self.GetConVar('ubuy_%s_check' % self.data[id][2]) == 1:
						self.data[id][0](id)
				else:
					# If the flag for the Check is enabled, it will call the function.
					if int(self.flags[-id]):
						self.data[id][0](id)
				if id >= len(self.data):
					break
				id += 1
			if self.error == False:
				weapon(self.userid,self.item)
	def check(self,id):
		chk = self.data[id][1]
		if chk() == 0:
			self.error = True
			msg(self.userid,chk(1),chk(2))
	def money_check(self,id):
		chk = self.data[id][1]
		if chk() == 0:
			self.error = True
			msg(self.userid,chk(1)[0],chk(2)[0])
			msg(self.userid,chk(1)[1],chk(2)[1])
	def enabled(self,type=0):
		if type == 0:
			return self.GetConVar('ubuy_%s_enabled' % self.item)
		elif type == 1:
			return 'restricted'
		elif type == 2:
			return {'weapon': lang(self.item,lang=playerlib.getPlayer(self.userid).get('lang'))}
	def alive(self,type=0):
		if type == 0:
			return not playerlib.getPlayer(self.userid).attributes['isdead']
		elif type == 1:
			return 'alive'
		elif type == 2:
			return {}
	def team_simple(self,type=0):
		var = self.GetConVar('ubuy_team_type',[0,2,3])
		if var == -1:
			return var
		if type == 0:
			return 1 if var == 0 else var == es.getplayerteam(self.userid)
		elif type == 1:
			team = {2: 'weapons_t',3: 'weapons_ct'}
			return team[var]
		elif type == 2:
			return {}
	def team_advanced(self,type=0):
		var = self.GetConVar('ubuy_%s_team' % self.item)
		if var == -1:
			return var
		if type == 0:
			return 1 if var == 0 else var == es.getplayerteam(self.userid)
		elif type == 1:
			team = {2: 'spec_weapons_t',3: 'spec_weapons_ct'}
			return team[var]
		elif type == 2:
			return {'weapon': lang(self.item,lang=playerlib.getPlayer(self.userid).get('lang'))}
	def buytime(self,type=0):
		if type == 0:
			global roundtime
			return (int(time()) - round_time) <= (es.getFloat('mp_buytime') * 60)
		elif type == 1:
			return 'buytime'
		elif type == 2:
			return {}
	def buyzone(self,type=0):
		if type == 0:
			return es.getplayerprop(self.userid,'CCSPlayer.m_bInBuyZone') & 1
		elif type == 1:
			return 'buyzone'
		elif type == 2:
			return {}
	def duplicate(self,type=0):
		if type == 0:
			wclass = items[self.item]
			if wclass == 1:
				return not playerlib.getPlayer(self.userid).get('primary') == self.item
			elif wclass == 2:
				return not playerlib.getPlayer(self.userid).get('secondary') == self.item
			else:
				if self.item == 'hegrenade':
					return not es.getplayerprop(self.userid, 'BasePlayer.localdata.m_iAmmo.011')
				elif self.item == 'flashbang':
					return not es.getplayerprop(self.userid, 'BasePlayer.localdata.m_iAmmo.012') > 1
				elif self.item == 'smokegrenade':
					return not es.getplayerprop(self.userid, 'BasePlayer.localdata.m_iAmmo.013')
				elif self.item == 'defuser':
					return not es.getplayerprop(self.userid, 'CCSPlayer.m_bHasDefuser') & 1
				elif self.item == 'nvgs':
					return not es.getplayerprop(self.userid, 'CCSPlayer.m_bHasNightVision') & 1
				else:
					return 1
		elif type == 1:
			return 'duplicate'
		elif type == 2:
			return {}
	def money(self,type=0):
		cost = es.getInt('ubuy_%s_cost' % self.item)
		if type == 0:
			money = es.getplayerprop(self.userid,'CCSPlayer.m_iAccount')
			if cost <= money:
				es.setplayerprop(self.userid,'CCSPlayer.m_iAccount',money-cost)
				return 1
			return 0
		elif type == 1:
			return ['money','moneyprice']
		elif type == 2:
			return [{},{'sign': '$','cost': cost,'weapon': lang(self.item,lang=playerlib.getPlayer(self.userid).get('lang'))}]
	def errormsg(self,token):
		self.error = True
		msg(self.userid,'variable error',{'var': token})
	def GetConVar(self,convar,varrange=[0,1]):
		var = es.getInt(convar)
		if var not in varrange:
			self.errormsg(convar)
			return -1
		return var
	def bin(self,x, digits=0):
		octs = ['000','001','010','011','100','101','110','111']
		binstr = [octs[int(n)] for n in oct(x)]
		return ''.join(binstr).lstrip('0').zfill(digits) 

def weapon(userid,arg):
	wclass = items[arg]
	chk = es.getInt('ubuy_drop_weapons')
	if chk == 1:
		user = playerlib.getPlayer(userid)
		if wclass == 1:
			prim = user.get('primary')
			if prim != '0':
				drop(userid,'weapon_%s' % prim)
		elif wclass == 2:
			sec = user.get('secondary')
			if sec != '0':
				drop(userid,'weapon_%s' % sec)
	elif chk == 0:
		user = playerlib.getPlayer(userid)
		prim = user.get('primary')
		sec = user.get('secondary')
		flash = es.getplayerprop(userid, 'CBasePlayer.localdata.m_iAmmo.012')
		armor = es.getplayerprop(userid,'CCSPlayer.m_ArmorValue')
		# Remove player equipment
		es.give(userid,'player_weaponstrip')
		index = es.getInt('eventscripts_lastgive')
		es.fire(index,'Strip')
		es.remove(index)
		# Give them their old weapons back...
		if wclass == 1:
			es.give(userid,'weapon_%s' % sec)
		elif wclass == 2:
			es.give(userid,'weapon_%s' % prim)
		es.give(userid,'weapon_knife')
		# Misc Items
		if es.getplayerprop(userid, 'CCSPlayer.m_bHasNightVision') & 1:
			es.setplayerprop(userid, 'CCSPlayer.m_bHasNightVision',1)
		if es.getplayerprop(userid, 'CCSPlayer.m_bHasDefuser') & 1:
			es.setplayerprop(userid, 'CCSPlayer.m_bHasDefuser',1)
		if es.getplayerprop(userid,'CCSPlayer.m_bHasHelmet') & 1:
			es.setplayerprop(userid,'CCSPlayer.m_bHasHelmet',1)
		if armor:
			es.setplayerprop(userid,'CCSPlayer.m_ArmorValue',armor)
		# Grenades
		if es.getplayerprop(userid, 'BasePlayer.localdata.m_iAmmo.011') and arg != 'hegrenade':
			es.setplayerprop(userid, 'CBasePlayer.localdata.m_iAmmo.011',1)
		if flash:
			if arg == 'flashbang':
				flash -= 1
			es.setplayerprop(userid, 'CBasePlayer.localdata.m_iAmmo.012',flash)
		if es.getplayerprop(userid, 'CBasePlayer.localdata.m_iAmmo.013') and arg != 'smokegrenade':
			es.setplayerprop(userid, 'CBasePlayer.localdata.m_iAmmo.013',1)
		if int(user.get('c4')):
			es.give(userid,'weapon_c4')
	else:
		msg(userid,'variable error',{'var': 'ubuy_drop_weapons'})
	if arg == 'vest':
		if es.getplayerprop(userid,'CCSPlayer.m_ArmorValue') >= 100:
			msg(userid,'vest_full')
			es.setplayerprop(userid,'CCSPlayer.m_iAccount',es.getplayerprop(userid,'CCSPlayer.m_iAccount')+es.getInt('ubuy_%s_cost' % arg))
		else:
			es.setplayerprop(userid,'CCSPlayer.m_ArmorValue',100)
			msg(userid,'purchase',{'weapon': lang(arg,lang=playerlib.getPlayer(userid).get('lang'))})
	elif arg == 'vesthelm':
		ap = es.getplayerprop(userid,'CCSPlayer.m_ArmorValue')
		helm = es.getplayerprop(userid,'CCSPlayer.m_bHasHelmet') & 1
		if ap < 100 and helm == 0:
			es.setplayerprop(userid,'CCSPlayer.m_ArmorValue',100)
			es.setplayerprop(userid,'CCSPlayer.m_bHasHelmet',1)
			msg(userid,'purchase',{'weapon': lang(arg,lang=playerlib.getPlayer(userid).get('lang'))})
		elif ap >= 100 and helm == 0:
			es.setplayerprop(userid,'CCSPlayer.m_iAccount',es.getplayerprop(userid,'CCSPlayer.m_iAccount')+es.getInt('ubuy_vest_cost'))
			es.setplayerprop(userid,'CCSPlayer.m_bHasHelmet',1)
			msg(userid,'purchase',{'weapon': lang(arg,lang=playerlib.getPlayer(userid).get('lang'))})
		elif ap < 100 and helm:
			es.setplayerprop(userid,'CCSPlayer.m_iAccount',es.getplayerprop(userid,'CCSPlayer.m_iAccount')+es.getInt('ubuy_vesthelm_cost')-es.getInt('ubuy_vest_cost'))
			es.setplayerprop(userid,'CCSPlayer.m_ArmorValue',100)
			msg(userid,'purchase',{'weapon': lang(arg,lang=playerlib.getPlayer(userid).get('lang'))})
		elif ap >= 100 and helm:
			msg(userid,'vest_full')
			es.setplayerprop(userid,'CCSPlayer.m_iAccount',es.getplayerprop(userid,'CCSPlayer.m_iAccount')+es.getInt('ubuy_vesthelm_cost'))
	elif arg in ['defuser','nvgs']:
		es.give(userid,'item_%s' % arg)
	elif arg in ['glock', 'usp', 'p228', 'deagle', 'fiveseven', 'elite', 'm3', 'xm1014', 'mac10', 'tmp', 'mp5navy', 'ump45', 'p90', 'galil', 'ak47', 'sg552', 'famas', 'm4a1', 'aug', 'm249', 'scout', 'awp', 'g3sg1', 'sg550', 'hegrenade', 'flashbang', 'smokegrenade']:
		es.give(userid,'weapon_%s' % arg)
	if wclass != -1:
		msg(userid,'purchase',{'weapon': lang(arg,lang=playerlib.getPlayer(userid).get('lang'))})

def drop(userid,weapon):
	es.sexec(userid,'use %s' % weapon)
	es.sexec(userid,'drop')
	

def msg(userid,msg,tokens={},type=0):
	if type == 0:
		msg = lang(msg,tokens,playerlib.getPlayer(userid).get('lang'))
	es.tell(userid,'#multi','#lightgreen[uBuy] %s' % msg)
	
def AddDownloads():
	convar = es.getInt('ubuy_restriction_sound_downloadable')
	if convar in [0,1]:
		sound = es.getString('ubuy_restriction_sound')
		if not "":
			if exists(es.getString('eventscripts_gamedir') + '/sound/' + sound):
				es.stringtable('downloadables','sound/' + sound)
			else:
				es.dbgmsg(0,'ultimate_buyscript: The file specified in ubuy_restriction_sound does not exist!')
	else:
		es.dbgmsg(0,'ultimate_buyscript: Something is wrong with ubuy_restriction_sound_downloadable!')